﻿"use strict";
var tinymce = tinymce || {};

//Register the plugin
tinymce.PluginManager.add('amazoneffectplugin', function (editor, url) {
    // Add a button that opens a window
    editor.addButton('amazoneffectplugin', {
        title: 'Amazon effect',
        image: window.location.protocol + '//' + window.location.hostname + (window.location.port === 80 || window.location.port === 443 ? '' : ':' + window.location.port) + '/EPiServer/Verndale.SSMLEditor/ClientResources/TinyMce/images/amazon-effect-epi.svg',
        onclick: function () {
            if (editor.selection.getNode().nodeName.toLowerCase() === "amazon:effect") {
                var previousValue = editor.selection.getNode().getAttribute("name");

                // Open window
                editor.windowManager.open({
                    title: 'Amazon effect edit plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'name',
                            label: 'Name',
                            values: [
                                { text: 'Whispered', value: 'whispered' }
                            ],
                            value: previousValue // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.select(editor.selection.getNode(), true);
                        var previousContent = editor.selection.getContent();

                        // Stores a bookmark of the current selection
                        var bm = editor.selection.getBookmark();
                        editor.selection.getNode().outerHTML = '<amazon:effect name="' + e.data.name + '">' + previousContent + '</amazon:effect>';
                        editor.selection.moveToBookmark(bm);
                    }
                });
            } else {
                // Open window
                editor.windowManager.open({
                    title: 'Amazon effect add plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'name',
                            label: 'Name',
                            values: [
                                { text: 'Whispered', value: 'whispered' }
                            ],
                            value: 'whispered' // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.setContent('<amazon:effect name="' + e.data.name + '">' + editor.selection.getContent() + '</amazon:effect>');
                        editor.focus();
                    }
                });
            }
        }
    });

    return {
        getMetadata: function () {
            return {
                name: 'Amazon effect plugin',
                url: 'https://cdisol.blog'
            };
        }
    };
});