﻿"use strict";
var tinymce = tinymce || {};

//Register the plugin
tinymce.PluginManager.add('breakplugin', function (editor, url) {
    // Add a button that opens a window
    editor.addButton('breakplugin', {
        title: 'Break',
        image: window.location.protocol + '//' + window.location.hostname + (window.location.port === 80 || window.location.port === 443 ? '' : ':' + window.location.port) + '/EPiServer/Verndale.SSMLEditor/ClientResources/TinyMce/images/break-epi.svg',
        onclick: function () {
            if (editor.selection.getNode().nodeName.toLowerCase() === "break") {
                var previousValueStrength = editor.selection.getNode().getAttribute("strength");
                var previousValueTime = editor.selection.getNode().getAttribute("time");

                // Open window
                editor.windowManager.open({
                    title: 'Break edit plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'strength',
                            label: 'Strength',
                            values: [
                                { text: 'None', value: 'none' },
                                { text: 'Extra Weak', value: 'x-weak' },
                                { text: 'Weak', value: 'weak' },
                                { text: 'Medium', value: 'medium' },
                                { text: 'Strong', value: 'strong' },
                                { text: 'Extra Strong', value: 'x-strong' }
                            ],
                            value: previousValueStrength // Sets the default
                        },
                        {
                            type: 'textbox',
                            name: 'time',
                            label: 'Time',
                            tooltip: 'Set break time',
                            value: previousValueTime // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.select(editor.selection.getNode(), true);
                        var previousContent = editor.selection.getContent();

                        // Stores a bookmark of the current selection
                        var bm = editor.selection.getBookmark();
                        editor.selection.getNode().outerHTML = '<break time="' + e.data.time + '" strength="' + e.data.strength + '">' + previousContent + '</break>';
                        editor.selection.moveToBookmark(bm);
                    }
                });
            } else {
                // Open window
                editor.windowManager.open({
                    title: 'Break add plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'strength',
                            label: 'Strength',
                            values: [
                                { text: 'None', value: 'none' },
                                { text: 'Extra Weak', value: 'x-weak' },
                                { text: 'Weak', value: 'weak' },
                                { text: 'Medium', value: 'medium' },
                                { text: 'Strong', value: 'strong' },
                                { text: 'Extra Strong', value: 'x-strong' }
                            ],
                            value: 'weak' // Sets the default
                        },
                        {
                            type: 'textbox',
                            name: 'time',
                            label: 'Time',
                            tooltip: 'Set break time',
                            value: '1s' // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.setContent('<break time="' + e.data.time + '" strength="' + e.data.strength + '">' + editor.selection.getContent() + '</break>');
                        editor.focus();
                    }
                });
            }
        }
    });

    return {
        getMetadata: function () {
            return {
                name: 'Break plugin',
                url: 'https://cdisol.blog'
            };
        }
    };
});