﻿"use strict";
var tinymce = tinymce || {};

//Register the plugin
tinymce.PluginManager.add('emphasisplugin', function (editor, url) {
    // Add a button that opens a window
    editor.addButton('emphasisplugin', {
        title: 'Emphasis',
        image: window.location.protocol + '//' + window.location.hostname + (window.location.port === 80 || window.location.port === 443 ? '' : ':' + window.location.port) + '/EPiServer/Verndale.SSMLEditor/ClientResources/TinyMce/images/emphasis-epi.svg',
        onclick: function () {
            if (editor.selection.getNode().nodeName.toLowerCase() === "emphasis") {
                var previousValue = editor.selection.getNode().getAttribute("level");

                // Open window
                editor.windowManager.open({
                    title: 'Emphasis edit plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'level',
                            label: 'Level',
                            values: [
                                { text: 'Strong', value: 'strong' },
                                { text: 'Moderate', value: 'moderate' },
                                { text: 'Reduced', value: 'reduced' }
                            ],
                            value: previousValue // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.select(editor.selection.getNode(), true);
                        var previousContent = editor.selection.getContent();

                        // Stores a bookmark of the current selection
                        var bm = editor.selection.getBookmark();
                        editor.selection.getNode().outerHTML = '<emphasis level="' + e.data.level + '">' + previousContent + '</emphasis>';
                        editor.selection.moveToBookmark(bm);
                    }
                });
            } else {
                // Open window
                editor.windowManager.open({
                    title: 'Emphasis add plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'level',
                            label: 'Level',
                            values: [
                                { text: 'Strong', value: 'strong' },
                                { text: 'Moderate', value: 'moderate' },
                                { text: 'Reduced', value: 'reduced' }
                            ],
                            value: 'moderate' // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.setContent('<emphasis level="' + e.data.level + '">' + editor.selection.getContent() + '</emphasis>');
                        editor.focus();
                    }
                });
            }
        }
    });

    return {
        getMetadata: function () {
            return {
                name: 'Emphasis plugin',
                url: 'https://cdisol.blog'
            };
        }
    };
});