﻿"use strict";
var tinymce = tinymce || {};

//Register the plugin
tinymce.PluginManager.add('langplugin', function (editor, url) {
    // Add a button that opens a window
    editor.addButton('langplugin', {
        title: 'Lang',
        image: window.location.protocol + '//' + window.location.hostname + (window.location.port === 80 || window.location.port === 443 ? '' : ':' + window.location.port) + '/EPiServer/Verndale.SSMLEditor/ClientResources/TinyMce/images/lang-epi.svg',
        onclick: function () {
            if (editor.selection.getNode().nodeName.toLowerCase() === "lang") {
                var previousValue = editor.selection.getNode().getAttribute("xml:lang");

                // Open window
                editor.windowManager.open({
                    title: 'Lang edit plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'lang',
                            label: 'Language',
                            values: [
                                { text: 'English - United States', value: 'en-US' },
                                { text: 'English - Britain', value: 'en-GB' },
                                { text: 'English - India', value: 'en-IN' },
                                { text: 'English - Australia', value: 'en-AU' },
                                { text: 'English - Canada', value: 'en-CA' },
                                { text: 'German', value: 'de-DE' },
                                { text: 'Spanish', value: 'es-ES' },
                                { text: 'Italian', value: 'it-IT' },
                                { text: 'Japanese', value: 'ja-JP' },
                                { text: 'French', value: 'fr-FR' }
                            ],
                            value: previousValue // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.select(editor.selection.getNode(), true);
                        var previousContent = editor.selection.getContent();

                        // Stores a bookmark of the current selection
                        var bm = editor.selection.getBookmark();
                        editor.selection.getNode().outerHTML = '<lang xml:lang="' + e.data.lang + '">' + previousContent + '</lang>';
                        editor.selection.moveToBookmark(bm);
                    }
                });
            } else {
                // Open window
                editor.windowManager.open({
                    title: 'Lang add plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'lang',
                            label: 'Language',
                            values: [
                                { text: 'English - United States', value: 'en-US' },
                                { text: 'English - Britain', value: 'en-GB' },
                                { text: 'English - India', value: 'en-IN' },
                                { text: 'English - Australia', value: 'en-AU' },
                                { text: 'English - Canada', value: 'en-CA' },
                                { text: 'German', value: 'de-DE' },
                                { text: 'Spanish', value: 'es-ES' },
                                { text: 'Italian', value: 'it-IT' },
                                { text: 'Japanese', value: 'ja-JP' },
                                { text: 'French', value: 'fr-FR' }
                            ],
                            value: 'en-US' // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.setContent('<lang xml:lang="' + e.data.lang + '">' + editor.selection.getContent() + '</lang>');
                        editor.focus();
                    }
                });
            }
        }
    });

    return {
        getMetadata: function () {
            return {
                name: 'Lang plugin',
                url: 'https://cdisol.blog'
            };
        }
    };
});