﻿"use strict";
var tinymce = tinymce || {};

//Register the plugin
tinymce.PluginManager.add('sayasplugin', function (editor, url) {
    // Add a button that opens a window
    editor.addButton('sayasplugin', {
        title: 'Say As',
        image: window.location.protocol + '//' + window.location.hostname + (window.location.port === 80 || window.location.port === 443 ? '' : ':' + window.location.port) + '/EPiServer/Verndale.SSMLEditor/ClientResources/TinyMce/images/say-as-epi.svg',
        onclick: function () {
            if (editor.selection.getNode().nodeName.toLowerCase() === "say-as") {
                var previousValueInterpretAs = editor.selection.getNode().getAttribute("interpret-as");
                var previousValueFormat = editor.selection.getNode().getAttribute("format") !== null ? editor.selection.getNode().getAttribute("format") : '';

                // Open window
                editor.windowManager.open({
                    title: 'Say As edit plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'interpretas',
                            label: 'Interpret As',
                            values: [
                                { text: 'Spell Out', value: 'spell-out' },
                                { text: 'Cardinal', value: 'cardinal' },
                                { text: 'Ordinal', value: 'ordinal' },
                                { text: 'Digits', value: 'digits' },
                                { text: 'Fraction', value: 'fraction' },
                                { text: 'Unit', value: 'unit' },
                                { text: 'Date', value: 'date' },
                                { text: 'Time', value: 'time' },
                                { text: 'Telephone', value: 'telephone' },
                                { text: 'Address', value: 'address' },
                                { text: 'Interjection', value: 'interjection' },
                                { text: 'Expletive', value: 'expletive' }
                            ],
                            value: previousValueInterpretAs // Sets the default
                        },
                        {
                            type: 'listbox',
                            name: 'format',
                            label: 'Format For Date',
                            values: [
                                { text: 'None', value: '' },
                                { text: 'Month - Day - Year', value: 'mdy' },
                                { text: 'Day - Month - Year', value: 'dmy' },
                                { text: 'Year - Month - Day', value: 'ymd' },
                                { text: 'Month - Day', value: 'md' },
                                { text: 'Day - Month', value: 'dm' },
                                { text: 'Year - Month', value: 'ym' },
                                { text: 'Month - Year', value: 'my' },
                                { text: 'Day', value: 'd' },
                                { text: 'Month', value: 'm' },
                                { text: 'Year', value: 'y' }
                            ],
                            value: previousValueFormat // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.select(editor.selection.getNode(), true);
                        var previousContent = editor.selection.getContent();
                        var tagHtml = '<say-as interpret-as="' + e.data.interpretas + '"';

                        if (e.data.format !== '') {
                            tagHtml += ' format="' + e.data.format + '" ';
                        }

                        tagHtml += '>';

                        // Stores a bookmark of the current selection
                        var bm = editor.selection.getBookmark();
                        editor.selection.getNode().outerHTML = tagHtml + previousContent + '</say-as>';
                        editor.selection.moveToBookmark(bm);
                    }
                });
            } else {
                // Open window
                editor.windowManager.open({
                    title: 'Say As add plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'interpretas',
                            label: 'Interpret As',
                            values: [
                                { text: 'Spell Out', value: 'spell-out' },
                                { text: 'Cardinal', value: 'cardinal' },
                                { text: 'Ordinal', value: 'ordinal' },
                                { text: 'Digits', value: 'digits' },
                                { text: 'Fraction', value: 'fraction' },
                                { text: 'Unit', value: 'unit' },
                                { text: 'Date', value: 'date' },
                                { text: 'Time', value: 'time' },
                                { text: 'Telephone', value: 'telephone' },
                                { text: 'Address', value: 'address' },
                                { text: 'Interjection', value: 'interjection' },
                                { text: 'Expletive', value: 'expletive' }
                            ],
                            value: 'spell-out' // Sets the default
                        },
                        {
                            type: 'listbox',
                            name: 'format',
                            label: 'Format For Date',
                            values: [
                                { text: 'None', value: '' },
                                { text: 'Month - Day - Year', value: 'mdy' },
                                { text: 'Day - Month - Year', value: 'dmy' },
                                { text: 'Year - Month - Day', value: 'ymd' },
                                { text: 'Month - Day', value: 'md' },
                                { text: 'Day - Month', value: 'dm' },
                                { text: 'Year - Month', value: 'ym' },
                                { text: 'Month - Year', value: 'my' },
                                { text: 'Day', value: 'd' },
                                { text: 'Month', value: 'm' },
                                { text: 'Year', value: 'y' }
                            ],
                            value: '' // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        var tagHtml = '<say-as interpret-as="' + e.data.interpretas + '"';

                        if (e.data.format !== '') {
                            tagHtml += ' format="' + e.data.format + '" ';
                        }

                        tagHtml += '>';

                        editor.selection.setContent(tagHtml + editor.selection.getContent() + '</say-as>');
                        editor.focus();
                    }
                });
            }
        }
    });

    return {
        getMetadata: function () {
            return {
                name: 'Say As plugin',
                url: 'https://cdisol.blog'
            };
        }
    };
});