﻿"use strict";
var tinymce = tinymce || {};

//Register the plugin
tinymce.PluginManager.add('subplugin', function (editor, url) {
    // Add a button that opens a window
    editor.addButton('subplugin', {
        title: 'Sub',
        image: window.location.protocol + '//' + window.location.hostname + (window.location.port === 80 || window.location.port === 443 ? '' : ':' + window.location.port) + '/EPiServer/Verndale.SSMLEditor/ClientResources/TinyMce/images/sub-alias-epi.svg',
        onclick: function () {
            if (editor.selection.getNode().nodeName.toLowerCase() === "sub") {
                var previousValue = editor.selection.getNode().getAttribute("alias");

                // Open window
                editor.windowManager.open({
                    title: 'Sub edit plugin',
                    body: [
                        {
                            type: 'textbox',
                            name: 'alias',
                            label: 'Alias',
                            tooltip: 'Set alias value',
                            value: previousValue // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.select(editor.selection.getNode(), true);
                        var previousContent = editor.selection.getContent();

                        // Stores a bookmark of the current selection
                        var bm = editor.selection.getBookmark();
                        editor.selection.getNode().outerHTML = '<sub alias="' + e.data.alias + '" >' + previousContent + '</sub>';
                        editor.selection.moveToBookmark(bm);
                    }
                });
            } else {
                // Open window
                editor.windowManager.open({
                    title: 'Sub add plugin',
                    body: [
                        {
                            type: 'textbox',
                            name: 'alias',
                            label: 'Alias',
                            tooltip: 'Set alias value',
                            value: '' // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.setContent('<sub alias="' + e.data.alias + '" >' + editor.selection.getContent() + '</sub>');
                        editor.focus();
                    }
                });
            }
        }
    });

    return {
        getMetadata: function () {
            return {
                name: 'Sub plugin',
                url: 'https://cdisol.blog'
            };
        }
    };
});