﻿"use strict";
var tinymce = tinymce || {};

//Register the plugin
tinymce.PluginManager.add('voiceplugin', function (editor, url) {
    // Add a button that opens a window
    editor.addButton('voiceplugin', {
        title: 'Voice',
        image: window.location.protocol + '//' + window.location.hostname + (window.location.port === 80 || window.location.port === 443 ? '' : ':' + window.location.port) + '/EPiServer/Verndale.SSMLEditor/ClientResources/TinyMce/images/voice-epi.svg',
        onclick: function () {
            if (editor.selection.getNode().parentNode.nodeName.toLowerCase() === "voice") {
                var previousValue = editor.selection.getNode().parentNode.getAttribute("name");

                // Open window
                editor.windowManager.open({
                    title: 'Voice edit plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'name',
                            label: 'Name',
                            values: [
                                { text: 'English, American - Ivy', value: 'Ivy' },
                                { text: 'English, American - Joanna', value: 'Joanna' },
                                { text: 'English, American - Joey', value: 'Joey' },
                                { text: 'English, American - Justin', value: 'Justin' },
                                { text: 'English, American - Kendra', value: 'Kendra' },
                                { text: 'English, American - Kimberly', value: 'Kimberly' },
                                { text: 'English, American - Matthew', value: 'Matthew' },
                                { text: 'English, American - Salli', value: 'Salli' },
                                { text: 'English, Australian - Nicole', value: 'Nicole' },
                                { text: 'English, Australian - Russell', value: 'Russell' },
                                { text: 'English, British - Amy', value: 'Amy' },
                                { text: 'English, British - Brian', value: 'Brian' },
                                { text: 'English, British - Emma', value: 'Emma' },
                                { text: 'English, Indian - Aditi', value: 'Aditi' },
                                { text: 'English, Indian - Raveena', value: 'Raveena' },
                                { text: 'German - Hans', value: 'Hans' },
                                { text: 'German - Marlene', value: 'Marlene' },
                                { text: 'German - Vicki', value: 'Vicki' },
                                { text: 'Spanish - Conchita', value: 'Conchita' },
                                { text: 'Spanish - Enrique', value: 'Enrique' },
                                { text: 'Italian - Carla', value: 'Carla' },
                                { text: 'Italian - Giorgio', value: 'Giorgio' },
                                { text: 'Japanese - Mizuki', value: 'Mizuki' },
                                { text: 'Japanese - Takumi', value: 'Takumi' },
                                { text: 'French - Celine', value: 'Celine' },
                                { text: 'French - Lea', value: 'Lea' },
                                { text: 'French - Mathieu', value: 'Mathieu' }
                            ],
                            value: previousValue // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        editor.selection.select(editor.selection.getNode().parentNode, true);
                        var previousContent = editor.selection.getContent();

                        var tagHtml = '<voice name="' + e.data.name + '">';

                        if (e.data.name === 'Ivy' || e.data.name === 'Joanna' || e.data.name === 'Joey' || e.data.name === 'Justin' ||
                            e.data.name === 'Kendra' || e.data.name === 'Kimberly' || e.data.name === 'Matthew' || e.data.name === 'Salli') {
                            tagHtml += '<lang xml:lang="en-US">' + previousContent + '</lang>';
                        }

                        if (e.data.name === 'Nicole' || e.data.name === 'Russell') {
                            tagHtml += '<lang xml:lang="en-AU">' + previousContent + '</lang>';
                        }

                        if (e.data.name === 'Amy' || e.data.name === 'Brian' || e.data.name === 'Emma') {
                            tagHtml += '<lang xml:lang="en-GB">' + previousContent + '</lang>';
                        }

                        if (e.data.name === 'Aditi' || e.data.name === 'Raveena') {
                            tagHtml += '<lang xml:lang="en-IN">' + previousContent + '</lang>';
                        }

                        if (e.data.name === 'Hans' || e.data.name === 'Marlene' || e.data.name === 'Vicki') {
                            tagHtml += '<lang xml:lang="de-DE">' + previousContent + '</lang>';
                        }

                        if (e.data.name === 'Conchita' || e.data.name === 'Enrique') {
                            tagHtml += '<lang xml:lang="es-ES">' + previousContent + '</lang>';
                        }

                        if (e.data.name === 'Carla' || e.data.name === 'Giorgio') {
                            tagHtml += '<lang xml:lang="it-IT">' + previousContent + '</lang>';
                        }

                        if (e.data.name === 'Mizuki' || e.data.name === 'Takumi') {
                            tagHtml += '<lang xml:lang="ja-JP">' + previousContent + '</lang>';
                        }

                        if (e.data.name === 'Celine' || e.data.name === 'Lea' || e.data.name === 'Mathieu') {
                            tagHtml += '<lang xml:lang="fr-FR">' + previousContent + '</lang>';
                        }

                        tagHtml += '</voice>';

                        // Stores a bookmark of the current selection
                        var bm = editor.selection.getBookmark();
                        editor.selection.getNode().parentNode.outerHTML = tagHtml;
                        editor.selection.moveToBookmark(bm);
                    }
                });
            } else {
                // Open window
                editor.windowManager.open({
                    title: 'Voice add plugin',
                    body: [
                        {
                            type: 'listbox',
                            name: 'name',
                            label: 'Name',
                            values: [
                                { text: 'English, American - Ivy', value: 'Ivy' },
                                { text: 'English, American - Joanna', value: 'Joanna' },
                                { text: 'English, American - Joey', value: 'Joey' },
                                { text: 'English, American - Justin', value: 'Justin' },
                                { text: 'English, American - Kendra', value: 'Kendra' },
                                { text: 'English, American - Kimberly', value: 'Kimberly' },
                                { text: 'English, American - Matthew', value: 'Matthew' },
                                { text: 'English, American - Salli', value: 'Salli' },
                                { text: 'English, Australian - Nicole', value: 'Nicole' },
                                { text: 'English, Australian - Russell', value: 'Russell' },
                                { text: 'English, British - Amy', value: 'Amy' },
                                { text: 'English, British - Brian', value: 'Brian' },
                                { text: 'English, British - Emma', value: 'Emma' },
                                { text: 'English, Indian - Aditi', value: 'Aditi' },
                                { text: 'English, Indian - Raveena', value: 'Raveena' },
                                { text: 'German - Hans', value: 'Hans' },
                                { text: 'German - Marlene', value: 'Marlene' },
                                { text: 'German - Vicki', value: 'Vicki' },
                                { text: 'Spanish - Conchita', value: 'Conchita' },
                                { text: 'Spanish - Enrique', value: 'Enrique' },
                                { text: 'Italian - Carla', value: 'Carla' },
                                { text: 'Italian - Giorgio', value: 'Giorgio' },
                                { text: 'Japanese - Mizuki', value: 'Mizuki' },
                                { text: 'Japanese - Takumi', value: 'Takumi' },
                                { text: 'French - Celine', value: 'Celine' },
                                { text: 'French - Lea', value: 'Lea' },
                                { text: 'French - Mathieu', value: 'Mathieu' }
                            ],
                            value: 'Ivy' // Sets the default
                        }
                    ],
                    onsubmit: function (e) {
                        var tagHtml = '<voice name="' + e.data.name + '">';

                        if (e.data.name === 'Ivy' || e.data.name === 'Joanna' || e.data.name === 'Joey' || e.data.name === 'Justin' ||
                            e.data.name === 'Kendra' || e.data.name === 'Kimberly' || e.data.name === 'Matthew' || e.data.name === 'Salli') {
                            tagHtml += '<lang xml:lang="en-US">' + editor.selection.getContent() + '</lang>';
                        }

                        if (e.data.name === 'Nicole' || e.data.name === 'Russell') {
                            tagHtml += '<lang xml:lang="en-AU">' + editor.selection.getContent() + '</lang>';
                        }

                        if (e.data.name === 'Amy' || e.data.name === 'Brian' || e.data.name === 'Emma') {
                            tagHtml += '<lang xml:lang="en-GB">' + editor.selection.getContent() + '</lang>';
                        }

                        if (e.data.name === 'Aditi' || e.data.name === 'Raveena') {
                            tagHtml += '<lang xml:lang="en-IN">' + editor.selection.getContent() + '</lang>';
                        }

                        if (e.data.name === 'Hans' || e.data.name === 'Marlene' || e.data.name === 'Vicki') {
                            tagHtml += '<lang xml:lang="de-DE">' + editor.selection.getContent() + '</lang>';
                        }

                        if (e.data.name === 'Conchita' || e.data.name === 'Enrique') {
                            tagHtml += '<lang xml:lang="es-ES">' + editor.selection.getContent() + '</lang>';
                        }

                        if (e.data.name === 'Carla' || e.data.name === 'Giorgio') {
                            tagHtml += '<lang xml:lang="it-IT">' + editor.selection.getContent() + '</lang>';
                        }

                        if (e.data.name === 'Mizuki' || e.data.name === 'Takumi') {
                            tagHtml += '<lang xml:lang="ja-JP">' + editor.selection.getContent() + '</lang>';
                        }

                        if (e.data.name === 'Celine' || e.data.name === 'Lea' || e.data.name === 'Mathieu') {
                            tagHtml += '<lang xml:lang="fr-FR">' + editor.selection.getContent() + '</lang>';
                        }

                        tagHtml += '</voice>';

                        editor.selection.setContent(tagHtml);
                        editor.focus();
                    }
                });
            }
        }
    });

    return {
        getMetadata: function () {
            return {
                name: 'Voice plugin',
                url: 'https://cdisol.blog'
            };
        }
    };
});